

(***************************************************)
(* Jose Luis Partida Sevillano                     *)
(***************************************************)



IMPLEMENTATION MODULE pantalla;


IMPORT FIO;
FROM Lib IMPORT Sound;
FROM IO IMPORT WrChar, WrStr;
FROM Storage IMPORT ALLOCATE, DEALLOCATE, Available;
FROM Window IMPORT GotoXY, Clear, TextColor, Color, CursorOff;
FROM barra IMPORT Tbarra, visualizarbarra, crearbarra;
FROM pelota IMPORT Tpelota, visualizarpelota, crearpelota, posicionpelotaY, posicionpelotaX, cambiadiresentido2;

TYPE
   Ttabla = POINTER TO muro;
   casilla= RECORD
              libre:BOOLEAN;
              car:CHAR;
            END;

   muro = ARRAY [1..42],[1..24] OF casilla;





(* Pongo todas las casillas de la tabla desocupadas para poder meter cualquier nivel *)


PROCEDURE iniciarp(VAR t:Ttabla; VAR pelot:Tpelota; VAR bara:Tbarra; VAR ok:BOOLEAN);

 VAR
   i, j:CARDINAL;

 BEGIN

   IF Available (SIZE(muro)) THEN
      NEW(t);

      FOR i:=2 TO 23 DO
          FOR j:=2 TO 41 DO
              t^[j,i].libre:=TRUE;
          END;
      END;
      ok:=TRUE;
   ELSE
      ok:=FALSE;
   END;

   crearbarra(bara, ok);
   crearpelota(pelot, ok);


END iniciarp;






(*--------------------------------------------------------------------------*)







(* Abro el fichero correspondiente y lo meto en la estructura*)

PROCEDURE crearp(VAR t:Ttabla; nivel:CARDINAL; VAR ok:BOOLEAN);

 CONST
   RET=CHR(13);
 VAR
   fich:FIO.File;
   j, i:CARDINAL;
   car, finlinea:CHAR;

 BEGIN
   (* Dependiendo del nivel introducido abriremos una pantalla determinada*)
   Clear;
   ok:=TRUE;
   CASE nivel OF

         1: fich:=FIO.Open("PANT1.DAT")|
         2: fich:=FIO.Open("PANT2.DAT")|
         3: fich:=FIO.Open("PANT3.DAT")|
         4: fich:=FIO.Open("PANT4.DAT");
      ELSE
         ok:=FALSE;
   END;


   FOR j:=2 TO 7 DO
       i:=1;
       car:=FIO.RdChar(fich);
       WHILE (i<=41) AND (car#RET) DO
           IF car='-' THEN
              t^[i,j].libre:=FALSE;
              t^[i,j].car:=CHR(220);
           ELSIF car='.' THEN
              t^[i,j].car:=' ';
           END;
           car:=FIO.RdChar(fich);
           INC(i);
       END;
   END;

   (* pongo las posiciones de la barra y de la pelota *)

   t^[20,17].libre:=FALSE;
   t^[21,17].libre:=FALSE;
   t^[22,17].libre:=FALSE;
   t^[23,17].libre:=FALSE;
   t^[24,17].libre:=FALSE;

   FIO.Close(fich);


END crearp;


(*--------------------------------------------------------------------------*)

(* Visualiza todo el juego *)


PROCEDURE visualizarp(t:Ttabla; pelot:Tpelota; bara:Tbarra);
 VAR
   i, j:CARDINAL;
   ptr:Ttabla;
 BEGIN
   CursorOff;
   IF t #NIL THEN
      (* zonas superior e inferior *)
      TextColor(Yellow);
      GotoXY(4,2);WrChar('');
      GotoXY(47,2);WrChar('');

      GotoXY(4,25);WrChar('');
      GotoXY(47,25);WrChar('');

      FOR j:=5 TO 46 DO
          GotoXY(j, 2); WrChar('');
          GotoXY(j, 25); WrChar('');
      END;

      (* zonas laterales *)

       FOR i:=3 TO 24 DO
           GotoXY(4,i);WrChar('');
           GotoXY(47,i);WrChar('');
       END;


       (* zona de juego *)
       TextColor(Blue);
       ptr:=t;
       FOR i:=2 TO 7 DO
           FOR j:=2 TO 41 DO
               GotoXY(4+j,2+i); WrChar(ptr^[j,i].car);
           END;
       END;

       FOR i:=8 TO 21 DO
           FOR j:=1 TO 41 DO
               GotoXY(4+j,2+i); WrChar(' ');
           END;
       END;

       FOR i:=1 TO 21 DO
           GotoXY(5,2+i);WrChar(' ');
           GotoXY(46,2+i);WrChar(' ');
       END;

       FOR j:=5 TO 46 DO
           GotoXY(j,3); WrChar(' ');
       END;
       TextColor(Red);
       GotoXY(52,1); WrStr("ͻ");
       GotoXY(52,2); WrStr("         ooooo          ");
       GotoXY(52,3); WrStr("           o            ");
       GotoXY(52,4); WrStr("           o            ");
       GotoXY(52,5); WrStr("         oooo           ");
       GotoXY(52,6); WrStr("         o  o           ");
       GotoXY(52,7); WrStr("         o   o          ");
       GotoXY(52,8); WrStr("                        ");
       GotoXY(52,9); WrStr("         oooo           ");
       GotoXY(52,10);WrStr("         o  o           ");
       GotoXY(52,11);WrStr("         oooo           ");
       GotoXY(52,12);WrStr("                        ");
       GotoXY(52,13);WrStr("         oo  o          ");
       GotoXY(52,14);WrStr("         o o o          ");
       GotoXY(52,15);WrStr("         o  oo          ");
       GotoXY(52,16);WrStr("                        ");
       GotoXY(52,17);WrStr("           oo           ");
       GotoXY(52,18);WrStr("           oo           ");
       GotoXY(52,19);WrStr("           oo           ");
       GotoXY(52,20);WrStr("                        ");
       GotoXY(52,21);WrStr("          ooooo         ");
       GotoXY(52,22);WrStr("          o             ");
       GotoXY(52,23);WrStr("          ooooo         ");
       GotoXY(52,24);WrStr("ͼ");


       (* posiciones de la barra y de la pelota *)
       TextColor(Red);
       visualizarbarra(bara);

       TextColor(LightGray);
       visualizarpelota(pelot);

   END;


END visualizarp;







(*--------------------------------------------------------------------------*)



(* Compruebo si ha tocado algn obstculo *)


PROCEDURE tocarobstaculo(t:Ttabla; pelot:Tpelota):BOOLEAN;
 BEGIN
   RETURN((t^[posicionpelotaX(pelot), posicionpelotaY(pelot)].libre=FALSE) AND (t^[posicionpelotaX(pelot), posicionpelotaY(pelot)].car=CHR(220)));
END tocarobstaculo;



(*--------------------------------------------------------------------------*)




(* Hago desparecer los obstculos tocados *)


PROCEDURE modificarpantalla(VAR t:Ttabla; VAR pelot:Tpelota);
 BEGIN
   IF tocarobstaculo(t, pelot) THEN
      t^[posicionpelotaX(pelot), posicionpelotaY(pelot)].libre:=TRUE;
      t^[posicionpelotaX(pelot), posicionpelotaY(pelot)].car:=CHR(32);
      Sound(500);
      cambiadiresentido2(pelot)

   END;

END modificarpantalla;






(*--------------------------------------------------------------------------*)




(* Compruebo si ha terminado el nivel *)


PROCEDURE finjuego(t:Ttabla):BOOLEAN;
 VAR
   pos1, pos2:CARDINAL;
   fin:BOOLEAN;
 BEGIN
   pos2:=1;
   pos1:=1;
   fin:=TRUE;
   WHILE (pos2<=17) AND fin DO
         WHILE (pos1<=40) AND fin DO
               IF t^[pos1,pos2].car#CHR(220) THEN
                  fin:=FALSE;
               END;
               INC(pos1);
         END;
         INC(pos2);
    END;
    RETURN (fin);

END finjuego;





(*--------------------------------------------------------------------------*)




PROCEDURE destruirpantalla(VAR t:Ttabla);
 BEGIN
   IF t#NIL THEN
      DISPOSE(t);
      t:=NIL;
   END;

END destruirpantalla;




END pantalla.


